_ExternalInterrupt0:
;Interrupts.c,54 :: 		void ExternalInterrupt0() iv IVT_INT_EXTI0 ics ICS_AUTO {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Interrupts.c,56 :: 		PR0_bit = 1;                      // Clear interrupt
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(PR0_bit+0)
MOVT	R0, #hi_addr(PR0_bit+0)
STR	R1, [R0, #0]
;Interrupts.c,58 :: 		if (++Pass > 99) {                // When counter overflows
MOVW	R1, #lo_addr(_Pass+0)
MOVT	R1, #hi_addr(_Pass+0)
LDRH	R0, [R1, #0]
ADDS	R0, R0, #1
UXTH	R0, R0
STRH	R0, [R1, #0]
CMP	R0, #99
IT	LS
BLS	L_ExternalInterrupt00
;Interrupts.c,59 :: 		Pass = 0;                     // Start again at 0
MOVS	R1, #0
MOVW	R0, #lo_addr(_Pass+0)
MOVT	R0, #hi_addr(_Pass+0)
STRH	R1, [R0, #0]
;Interrupts.c,60 :: 		IntFlag = 1;                  // Set interrupt flag
MOVS	R1, #1
MOVW	R0, #lo_addr(_IntFlag+0)
MOVT	R0, #hi_addr(_IntFlag+0)
STRB	R1, [R0, #0]
;Interrupts.c,61 :: 		RGB_Set_Red();                // Diagnostic
BL	_RGB_Set_Red+0
;Interrupts.c,62 :: 		}
L_ExternalInterrupt00:
;Interrupts.c,63 :: 		}
L_end_ExternalInterrupt0:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _ExternalInterrupt0
_ExtIntEnable:
;Interrupts.c,68 :: 		void ExtIntEnable(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Interrupts.c,71 :: 		GPIO_Set_Pin_Mode(&GPIOE_BASE, _GPIO_PIN_0, _GPIO_CFG_MODE_INPUT | _GPIO_CFG_PULL_UP);
MOVS	R2, #130
MOVW	R1, #0
MOVW	R0, #lo_addr(GPIOE_BASE+0)
MOVT	R0, #hi_addr(GPIOE_BASE+0)
BL	_GPIO_Set_Pin_Mode+0
;Interrupts.c,74 :: 		MR0_bit = 1;                      // Unmask interrupt request from line 0
MOVS	R2, #1
SXTB	R2, R2
MOVW	R0, #lo_addr(MR0_bit+0)
MOVT	R0, #hi_addr(MR0_bit+0)
STR	R2, [R0, #0]
;Interrupts.c,77 :: 		TR0_bit = 1;                      // Enable rising trigger
MOVW	R0, #lo_addr(TR0_bit+0)
MOVT	R0, #hi_addr(TR0_bit+0)
STR	R2, [R0, #0]
;Interrupts.c,80 :: 		TR0_EXTI_FTSR_bit = 0;            // Disable falling trigger
MOVS	R1, #0
SXTB	R1, R1
MOVW	R0, #lo_addr(TR0_EXTI_FTSR_bit+0)
MOVT	R0, #hi_addr(TR0_EXTI_FTSR_bit+0)
STR	R1, [R0, #0]
;Interrupts.c,83 :: 		SYSCFGEN_bit = 1;                 // Enable system configuration controller clock
MOVW	R0, #lo_addr(SYSCFGEN_bit+0)
MOVT	R0, #hi_addr(SYSCFGEN_bit+0)
STR	R2, [R0, #0]
;Interrupts.c,86 :: 		SYSCFG_EXTICR1 = 0x00000004;      // Connect PE0 to EXTI0
MOVS	R1, #4
MOVW	R0, #lo_addr(SYSCFG_EXTICR1+0)
MOVT	R0, #hi_addr(SYSCFG_EXTICR1+0)
STR	R1, [R0, #0]
;Interrupts.c,88 :: 		NVIC_IntEnable(IVT_INT_EXTI0);    // Enable EXTI0 interrupt
MOVW	R0, #22
BL	_NVIC_IntEnable+0
;Interrupts.c,90 :: 		InPtr = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_InPtr+0)
MOVT	R0, #hi_addr(_InPtr+0)
STRH	R1, [R0, #0]
;Interrupts.c,91 :: 		}
L_end_ExtIntEnable:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _ExtIntEnable
_CheckPA0Int:
;Interrupts.c,96 :: 		void CheckPA0Int(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Interrupts.c,99 :: 		if (IntFlag) {                    // If interrupt flag is set
MOVW	R0, #lo_addr(_IntFlag+0)
MOVT	R0, #hi_addr(_IntFlag+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_CheckPA0Int1
;Interrupts.c,100 :: 		IntFlag = 0;                  // Clear interrupt flag
MOVS	R1, #0
MOVW	R0, #lo_addr(_IntFlag+0)
MOVT	R0, #hi_addr(_IntFlag+0)
STRB	R1, [R0, #0]
;Interrupts.c,101 :: 		RGB_Clr_Red();                // Diagnostic
BL	_RGB_Clr_Red+0
;Interrupts.c,103 :: 		NewValue = ReadTimer6();      // Get the Timer6 free-running counter
BL	_ReadTimer6+0
MOVW	R1, #lo_addr(_NewValue+0)
MOVT	R1, #hi_addr(_NewValue+0)
STRH	R0, [R1, #0]
;Interrupts.c,105 :: 		Sum = 0;                      // Initialize Sum prior to averaging calculation
MOVS	R2, #0
MOVW	R1, #lo_addr(_Sum+0)
MOVT	R1, #hi_addr(_Sum+0)
STR	R2, [R1, #0]
;Interrupts.c,107 :: 		ValueTable[InPtr++] = NewValue - OldValue; // Subtract the old counter value from the new
MOVW	R3, #lo_addr(_InPtr+0)
MOVT	R3, #hi_addr(_InPtr+0)
LDRH	R1, [R3, #0]
LSLS	R2, R1, #1
MOVW	R1, #lo_addr(_ValueTable+0)
MOVT	R1, #hi_addr(_ValueTable+0)
ADDS	R2, R1, R2
MOVW	R1, #lo_addr(_OldValue+0)
MOVT	R1, #hi_addr(_OldValue+0)
LDRH	R1, [R1, #0]
SUB	R0, R0, R1
STRH	R0, [R2, #0]
MOV	R0, R3
LDRH	R0, [R0, #0]
ADDS	R0, R0, #1
UXTH	R0, R0
STRH	R0, [R3, #0]
;Interrupts.c,110 :: 		if (InPtr > 3) InPtr = 0;     // If buffer pointer exceeded buffer length set it to 0
CMP	R0, #3
IT	LS
BLS	L_CheckPA0Int2
MOVS	R1, #0
MOVW	R0, #lo_addr(_InPtr+0)
MOVT	R0, #hi_addr(_InPtr+0)
STRH	R1, [R0, #0]
L_CheckPA0Int2:
;Interrupts.c,112 :: 		for (i=0;i<4;i++) {
; i start address is: 12 (R3)
MOVS	R3, #0
SXTH	R3, R3
; i end address is: 12 (R3)
L_CheckPA0Int3:
; i start address is: 12 (R3)
CMP	R3, #4
IT	GE
BGE	L_CheckPA0Int4
;Interrupts.c,113 :: 		Sum += ValueTable[i];    // Sum the 4 most recent counter values
LSLS	R1, R3, #1
MOVW	R0, #lo_addr(_ValueTable+0)
MOVT	R0, #hi_addr(_ValueTable+0)
ADDS	R0, R0, R1
LDRH	R2, [R0, #0]
MOVW	R1, #lo_addr(_Sum+0)
MOVT	R1, #hi_addr(_Sum+0)
LDR	R0, [R1, #0]
ADDS	R0, R0, R2
STR	R0, [R1, #0]
;Interrupts.c,112 :: 		for (i=0;i<4;i++) {
ADDS	R3, R3, #1
SXTH	R3, R3
;Interrupts.c,114 :: 		}
; i end address is: 12 (R3)
IT	AL
BAL	L_CheckPA0Int3
L_CheckPA0Int4:
;Interrupts.c,115 :: 		Average = (unsigned int)(Sum >> 2); // Divide by 4 to get average value
MOVW	R0, #lo_addr(_Sum+0)
MOVT	R0, #hi_addr(_Sum+0)
LDR	R0, [R0, #0]
LSRS	R0, R0, #2
UXTH	R1, R0
MOVW	R0, #lo_addr(_Average+0)
MOVT	R0, #hi_addr(_Average+0)
STRH	R1, [R0, #0]
;Interrupts.c,117 :: 		OldValue = NewValue;          // Save most recent counter reading
MOVW	R0, #lo_addr(_NewValue+0)
MOVT	R0, #hi_addr(_NewValue+0)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_OldValue+0)
MOVT	R0, #hi_addr(_OldValue+0)
STRH	R1, [R0, #0]
;Interrupts.c,119 :: 		if (Tuned) {
MOVW	R0, #lo_addr(_Tuned+0)
MOVT	R0, #hi_addr(_Tuned+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_CheckPA0Int6
;Interrupts.c,120 :: 		if ((Average < LowThresh) && (DetFlag == 0)) {  // If below this value
MOVW	R0, #lo_addr(_LowThresh+0)
MOVT	R0, #hi_addr(_LowThresh+0)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_Average+0)
MOVT	R0, #hi_addr(_Average+0)
LDRH	R0, [R0, #0]
CMP	R0, R1
IT	CS
BCS	L__CheckPA0Int30
MOVW	R0, #lo_addr(_DetFlag+0)
MOVT	R0, #hi_addr(_DetFlag+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L__CheckPA0Int29
L__CheckPA0Int28:
;Interrupts.c,121 :: 		UART6_PutQueue("Vehicle present\r\n");      // indicate vehicle present
MOVW	R0, #lo_addr(?lstr1_Interrupts+0)
MOVT	R0, #hi_addr(?lstr1_Interrupts+0)
BL	_UART6_PutQueue+0
;Interrupts.c,122 :: 		DetFlag = 1;                                // Flip detect flag
MOVS	R1, #1
MOVW	R0, #lo_addr(_DetFlag+0)
MOVT	R0, #hi_addr(_DetFlag+0)
STRB	R1, [R0, #0]
;Interrupts.c,120 :: 		if ((Average < LowThresh) && (DetFlag == 0)) {  // If below this value
L__CheckPA0Int30:
L__CheckPA0Int29:
;Interrupts.c,125 :: 		if ((Average > HighThresh) && (DetFlag == 1)) {  // If above this vlue
MOVW	R0, #lo_addr(_HighThresh+0)
MOVT	R0, #hi_addr(_HighThresh+0)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_Average+0)
MOVT	R0, #hi_addr(_Average+0)
LDRH	R0, [R0, #0]
CMP	R0, R1
IT	LS
BLS	L__CheckPA0Int32
MOVW	R0, #lo_addr(_DetFlag+0)
MOVT	R0, #hi_addr(_DetFlag+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	NE
BNE	L__CheckPA0Int31
L__CheckPA0Int27:
;Interrupts.c,126 :: 		UART6_PutQueue("Vehicle absent\r\n");        // indicate vehicle absent
MOVW	R0, #lo_addr(?lstr2_Interrupts+0)
MOVT	R0, #hi_addr(?lstr2_Interrupts+0)
BL	_UART6_PutQueue+0
;Interrupts.c,127 :: 		DetFlag = 0;                                 // Flip detect flag
MOVS	R1, #0
MOVW	R0, #lo_addr(_DetFlag+0)
MOVT	R0, #hi_addr(_DetFlag+0)
STRB	R1, [R0, #0]
;Interrupts.c,125 :: 		if ((Average > HighThresh) && (DetFlag == 1)) {  // If above this vlue
L__CheckPA0Int32:
L__CheckPA0Int31:
;Interrupts.c,129 :: 		}
L_CheckPA0Int6:
;Interrupts.c,131 :: 		}
L_CheckPA0Int1:
;Interrupts.c,132 :: 		}
L_end_CheckPA0Int:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _CheckPA0Int
_LoopSM:
;Interrupts.c,137 :: 		void LoopSM(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;Interrupts.c,141 :: 		switch (LoopState) {
IT	AL
BAL	L_LoopSM13
;Interrupts.c,143 :: 		case 0: // Not used
L_LoopSM15:
;Interrupts.c,145 :: 		break;
IT	AL
BAL	L_LoopSM14
;Interrupts.c,147 :: 		case 1: // Set timer to delay 500 ms
L_LoopSM16:
;Interrupts.c,148 :: 		LoopTimer = get_timer();            // Get a timer handle
BL	_get_timer+0
MOVW	R1, #lo_addr(_LoopTimer+0)
MOVT	R1, #hi_addr(_LoopTimer+0)
STRB	R0, [R1, #0]
;Interrupts.c,149 :: 		set_timer(LoopTimer,5000);           // Set timer
MOVW	R1, #5000
BL	_set_timer+0
;Interrupts.c,150 :: 		UART6_PutQueue("Waiting for loop to stabilize. Please wait...\r\n");
MOVW	R0, #lo_addr(?lstr3_Interrupts+0)
MOVT	R0, #hi_addr(?lstr3_Interrupts+0)
BL	_UART6_PutQueue+0
;Interrupts.c,151 :: 		LoopState = 2;
MOVS	R1, #2
MOVW	R0, #lo_addr(_LoopState+0)
MOVT	R0, #hi_addr(_LoopState+0)
STRB	R1, [R0, #0]
;Interrupts.c,152 :: 		break;
IT	AL
BAL	L_LoopSM14
;Interrupts.c,154 :: 		case 2: // Set loop thresholds
L_LoopSM17:
;Interrupts.c,155 :: 		if (check_timer(LoopTimer) == 0) {
MOVW	R0, #lo_addr(_LoopTimer+0)
MOVT	R0, #hi_addr(_LoopTimer+0)
LDRB	R0, [R0, #0]
BL	_check_timer+0
CMP	R0, #0
IT	NE
BNE	L_LoopSM18
;Interrupts.c,157 :: 		UART6_PutQueue("Tuning loop\r\n");
MOVW	R0, #lo_addr(?lstr4_Interrupts+0)
MOVT	R0, #hi_addr(?lstr4_Interrupts+0)
BL	_UART6_PutQueue+0
;Interrupts.c,159 :: 		HighThresh = Average - UPPER;
MOVW	R2, #lo_addr(_Average+0)
MOVT	R2, #hi_addr(_Average+0)
LDRH	R0, [R2, #0]
SUBW	R1, R0, #16
MOVW	R0, #lo_addr(_HighThresh+0)
MOVT	R0, #hi_addr(_HighThresh+0)
STRH	R1, [R0, #0]
;Interrupts.c,160 :: 		LowThresh  = Average - LOWER;
MOV	R0, R2
LDRH	R0, [R0, #0]
SUBW	R1, R0, #32
MOVW	R0, #lo_addr(_LowThresh+0)
MOVT	R0, #hi_addr(_LowThresh+0)
STRH	R1, [R0, #0]
;Interrupts.c,167 :: 		Tuned = 1;
MOVS	R1, #1
MOVW	R0, #lo_addr(_Tuned+0)
MOVT	R0, #hi_addr(_Tuned+0)
STRB	R1, [R0, #0]
;Interrupts.c,168 :: 		UART6_PutQueue("Ready\r\n");
MOVW	R0, #lo_addr(?lstr5_Interrupts+0)
MOVT	R0, #hi_addr(?lstr5_Interrupts+0)
BL	_UART6_PutQueue+0
;Interrupts.c,169 :: 		set_timer(LoopTimer,60000);     // Set timer for 1 minute
MOVW	R0, #lo_addr(_LoopTimer+0)
MOVT	R0, #hi_addr(_LoopTimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #60000
BL	_set_timer+0
;Interrupts.c,170 :: 		LoopState = 3;
MOVS	R1, #3
MOVW	R0, #lo_addr(_LoopState+0)
MOVT	R0, #hi_addr(_LoopState+0)
STRB	R1, [R0, #0]
;Interrupts.c,171 :: 		}
L_LoopSM18:
;Interrupts.c,172 :: 		break;
IT	AL
BAL	L_LoopSM14
;Interrupts.c,174 :: 		case 3: // Wait 1 minute. Do not proceed if vehicle is over the loop
L_LoopSM19:
;Interrupts.c,175 :: 		if ((check_timer(LoopTimer) == 0) && (DetFlag == 0)) {
MOVW	R0, #lo_addr(_LoopTimer+0)
MOVT	R0, #hi_addr(_LoopTimer+0)
LDRB	R0, [R0, #0]
BL	_check_timer+0
CMP	R0, #0
IT	NE
BNE	L__LoopSM36
MOVW	R0, #lo_addr(_DetFlag+0)
MOVT	R0, #hi_addr(_DetFlag+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L__LoopSM35
L__LoopSM34:
;Interrupts.c,176 :: 		UART6_PutQueue("Tuning loop\r\n");
MOVW	R0, #lo_addr(?lstr6_Interrupts+0)
MOVT	R0, #hi_addr(?lstr6_Interrupts+0)
BL	_UART6_PutQueue+0
;Interrupts.c,177 :: 		LoopState = 4;
MOVS	R1, #4
MOVW	R0, #lo_addr(_LoopState+0)
MOVT	R0, #hi_addr(_LoopState+0)
STRB	R1, [R0, #0]
;Interrupts.c,175 :: 		if ((check_timer(LoopTimer) == 0) && (DetFlag == 0)) {
L__LoopSM36:
L__LoopSM35:
;Interrupts.c,179 :: 		break;
IT	AL
BAL	L_LoopSM14
;Interrupts.c,181 :: 		case 4: //  Tune loop and set timer for another minute
L_LoopSM23:
;Interrupts.c,182 :: 		if ((check_timer(LoopTimer) == 0) && (DetFlag == 0)) {
MOVW	R0, #lo_addr(_LoopTimer+0)
MOVT	R0, #hi_addr(_LoopTimer+0)
LDRB	R0, [R0, #0]
BL	_check_timer+0
CMP	R0, #0
IT	NE
BNE	L__LoopSM38
MOVW	R0, #lo_addr(_DetFlag+0)
MOVT	R0, #hi_addr(_DetFlag+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	NE
BNE	L__LoopSM37
L__LoopSM33:
;Interrupts.c,183 :: 		HighThresh = Average - UPPER;
MOVW	R2, #lo_addr(_Average+0)
MOVT	R2, #hi_addr(_Average+0)
LDRH	R0, [R2, #0]
SUBW	R1, R0, #16
MOVW	R0, #lo_addr(_HighThresh+0)
MOVT	R0, #hi_addr(_HighThresh+0)
STRH	R1, [R0, #0]
;Interrupts.c,184 :: 		LowThresh  = Average - LOWER;
MOV	R0, R2
LDRH	R0, [R0, #0]
SUBW	R1, R0, #32
MOVW	R0, #lo_addr(_LowThresh+0)
MOVT	R0, #hi_addr(_LowThresh+0)
STRH	R1, [R0, #0]
;Interrupts.c,191 :: 		set_timer(LoopTimer,60000);     // Set timer for 1 minute
MOVW	R0, #lo_addr(_LoopTimer+0)
MOVT	R0, #hi_addr(_LoopTimer+0)
LDRB	R0, [R0, #0]
MOVW	R1, #60000
BL	_set_timer+0
;Interrupts.c,192 :: 		LoopState = 3;
MOVS	R1, #3
MOVW	R0, #lo_addr(_LoopState+0)
MOVT	R0, #hi_addr(_LoopState+0)
STRB	R1, [R0, #0]
;Interrupts.c,182 :: 		if ((check_timer(LoopTimer) == 0) && (DetFlag == 0)) {
L__LoopSM38:
L__LoopSM37:
;Interrupts.c,194 :: 		break;
IT	AL
BAL	L_LoopSM14
;Interrupts.c,197 :: 		}
L_LoopSM13:
MOVW	R0, #lo_addr(_LoopState+0)
MOVT	R0, #hi_addr(_LoopState+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	EQ
BEQ	L_LoopSM15
MOVW	R0, #lo_addr(_LoopState+0)
MOVT	R0, #hi_addr(_LoopState+0)
LDRB	R0, [R0, #0]
CMP	R0, #1
IT	EQ
BEQ	L_LoopSM16
MOVW	R0, #lo_addr(_LoopState+0)
MOVT	R0, #hi_addr(_LoopState+0)
LDRB	R0, [R0, #0]
CMP	R0, #2
IT	EQ
BEQ	L_LoopSM17
MOVW	R0, #lo_addr(_LoopState+0)
MOVT	R0, #hi_addr(_LoopState+0)
LDRB	R0, [R0, #0]
CMP	R0, #3
IT	EQ
BEQ	L_LoopSM19
MOVW	R0, #lo_addr(_LoopState+0)
MOVT	R0, #hi_addr(_LoopState+0)
LDRB	R0, [R0, #0]
CMP	R0, #4
IT	EQ
BEQ	L_LoopSM23
L_LoopSM14:
;Interrupts.c,198 :: 		}
L_end_LoopSM:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _LoopSM
