#line 1 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/UART6.c"
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/uart6.h"
#line 20 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/uart6.h"
typedef void (*tPointerFcn)(void);





void UART6_SetBaud(void);
void UART6_StartRx(void);
void UART6_StartTx(void);

void UART6_Initialize(void);

void UART6_RxQueueInit(void);
char UART6_GetChar(char *rxbyte);

void UART6_Rx(void);
void UART6_Rx1(void);
void UART6_Rx2(void);


void UART6_TxQueueInit(void);
void UART6_PutQueue(char *msg);

void UART6_SendMsg(char *s);
void UART6_CheckQueue(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/buffers.h"
#line 14 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/buffers.h"
char* GetBuffer(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/rgb.h"
#line 13 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/rgb.h"
void RGB_Init(void);
void RGB_Set_Red(void);
void RGB_Clr_Red(void);
void RGB_Set_Green(void);
void RGB_Clr_Green(void);
void RGB_Set_Blue(void);
void RGB_Clr_Blue(void);
#pragma funcall UART6_Rx1, UART6_Rx2
#line 35 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/UART6.c"
char RxIn;
char RxOut;
char RxQueue[ 256 ];

char RcvBuf[ 256 ];
char RcvBufPtr;


char TxIn;
char TxOut;
char *TxQueue[ 1024 ];

char *XmtBuf;
char XmtBufPtr;



tPointerFcn UART6_RxFuncPtr = UART6_Rx1;

extern unsigned int Average;
extern unsigned long Sum;
extern char LoopState;
extern unsigned int LowThresh;
extern unsigned int HighThresh;
#line 66 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/UART6.c"
void UART6_Interrupt() iv IVT_INT_USART6 ics ICS_AUTO {
 char R_data;
 char T_data;


 if ((RXNE_USART6_SR_bit) ) {
 R_data = USART6_DR;
 RxQueue[RxIn++] = R_data;
 if (RxIn > ( 256 -1))
 RxIn = 0;
 }

 if ((TXE_USART6_SR_bit)&&(TXEIE_USART6_CR1_bit)) {
 T_data = XmtBuf[XmtBufPtr++];
 if (T_data ==  0x00 ) {
 TXEIE_USART6_CR1_bit = 0;
 } else {
 USART6_DR = T_data;
 }
 }
}
#line 90 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/UART6.c"
void UART6_SetBaud(void) {







 UART6_Init_Advanced(9600,_UART_8_BIT_DATA,_UART_NOPARITY,_UART_ONE_STOPBIT,
 &_GPIO_MODULE_USART6_PC67);
#line 116 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/UART6.c"
 NVIC_IntEnable(IVT_INT_USART6);

}
#line 122 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/UART6.c"
void UART6_StartRx(void) {
 RXNEIE_USART6_CR1_bit = 1;
}
#line 128 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/UART6.c"
void UART6_StartTx(void) {
 TXEIE_USART6_CR1_bit = 1;
}
#line 139 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/UART6.c"
void UART6_Initialize(void) {
 UART6_RxQueueInit();
 UART6_TxQueueInit();

 UART6_SetBaud();
 UART6_StartRx();
}
#line 150 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/UART6.c"
void UART6_RxQueueInit(void) {
 RxIn = RxOut = 0;
 RcvBufPtr = 0;
}
#line 159 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/UART6.c"
char UART6_GetChar(char *rxbyte) {
 if (RxIn != RxOut) {
 *rxbyte = RxQueue[RxOut++];
 if (RxOut > ( 256 -1))
 RxOut = 0;
 return 1;
 }else{
 return 0;
 }
}
#line 172 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/UART6.c"
void UART6_Rx(void) {
 UART6_RxFuncPtr();
}
#line 179 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/UART6.c"
void UART6_Rx1(void){
 char rxchar;

 if (UART6_GetChar(&rxchar)) {
 switch (rxchar) {
 case  0x00 :
 break;

 case '\r':
 break;

 case '\n':
 RcvBuf[RcvBufPtr++] = rxchar;
 RcvBuf[RcvBufPtr] = 0;
 RcvBufPtr = 0;
 UART6_RxFuncPtr = UART6_Rx2;
 break;

 default:
 if (RcvBufPtr < ( 256 -2))
 RcvBuf[RcvBufPtr++] = rxchar;
 break;
 }
 }
}
#line 208 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/UART6.c"
void UART6_Rx2(void) {
 char *BufNum;
 unsigned clk;
 float Frequency;

 switch (RcvBuf[0]) {



 case 'a':
 UART6_PutQueue("Command 'a' received\r\n");
 break;

 case 'b':
 BufNum = GetBuffer();
 sprintf(BufNum,"Timer6: %04X\r\n",TIM6_CNT);
 UART6_PutQueue(BufNum);
 break;

 case 'c':
 BufNum = GetBuffer();
 sprintf(BufNum,"Sum value: %08LX\r\n",Sum);
 UART6_PutQueue(BufNum);
 break;

 case 'd':
 BufNum = GetBuffer();
 sprintf(BufNum,"Average value: %04X\r\n",Average);
 UART6_PutQueue(BufNum);
 break;

 case 'e':
 clk = Clock_Mhz();
 BufNum = GetBuffer();
 sprintf(BufNum,"Clock: %d\r\n",clk);
 UART6_PutQueue(BufNum);
 break;

 case 'f':
 BufNum = GetBuffer();
 sprintf(BufNum,"State: %d\r\n",LoopState);
 UART6_PutQueue(BufNum);
 break;

 case 'g':
 BufNum = GetBuffer();
 sprintf(BufNum,"Lower threshold: %04X\r\n",LowThresh);
 UART6_PutQueue(BufNum);
 break;

 case 'h':
 BufNum = GetBuffer();
 sprintf(BufNum,"Upper threshold: %04X\r\n",HighThresh);
 UART6_PutQueue(BufNum);
 break;

 case 'i':
 LoopState = 1;
 break;

 case 'j':
 Frequency = 1 / (Average * 0.000000001);
 BufNum = GetBuffer();
 sprintf(BufNum,"Loop oscillator frequency: %5.2f Hz\r\n",Frequency);
 UART6_PutQueue(BufNum);
 break;

 case 'k':
 break;

 case 'l':
 break;

 case 'm':
 break;

 case 'n':
 break;

 case 'o':
 break;

 case 'p':
 break;

 case 'r':
 break;

 case 's':
 break;

 case 't':
 break;

 case 'u':
 break;

 case 'v':
 break;

 case 'w':
 break;

 case 'x':
 break;

 case 'y':
 break;

 case 'z':
 break;


 default:
 UART6_PutQueue("Unknown command: ");

 BufNum = GetBuffer();
 (void)sprintf(BufNum,"%c\r\n",RcvBuf[0]);
 UART6_PutQueue(BufNum);
 break;
 }
 UART6_RxFuncPtr = UART6_Rx1;
}
#line 337 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/UART6.c"
void UART6_TxQueueInit(void) {
 TxIn = TxOut = 0;
 XmtBufPtr = 0;
}
#line 345 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/UART6.c"
void UART6_PutQueue(char *msg) {
 TxQueue[TxIn++] = msg;
 if (TxIn > ( 1024 -1))
 TxIn = 0;
}
#line 353 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/UART6.c"
void UART6_SendMsg(char *s) {
 XmtBuf = s;
 XmtBufPtr = 0;
 UART6_StartTx();
}
#line 362 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/UART6.c"
void UART6_CheckQueue(void) {
 if (TXEIE_USART6_CR1_bit == 0) {
 if (TxIn != TxOut) {
 UART6_SendMsg(TxQueue[TxOut++]);
 if (TxOut > ( 1024 -1))
 TxOut = 0;
 }
 }
}
