#line 1 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/Interrupts.c"
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/interrupts.h"
#line 14 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/interrupts.h"
void ExtIntEnable(void);
void CheckPA0Int(void);

void LoopSM(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/buffers.h"
#line 14 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/buffers.h"
char* GetBuffer(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/rgb.h"
#line 13 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/rgb.h"
void RGB_Init(void);
void RGB_Set_Red(void);
void RGB_Clr_Red(void);
void RGB_Set_Green(void);
void RGB_Clr_Green(void);
void RGB_Set_Blue(void);
void RGB_Clr_Blue(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/uart6.h"
#line 20 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/uart6.h"
typedef void (*tPointerFcn)(void);





void UART6_SetBaud(void);
void UART6_StartRx(void);
void UART6_StartTx(void);

void UART6_Initialize(void);

void UART6_RxQueueInit(void);
char UART6_GetChar(char *rxbyte);

void UART6_Rx(void);
void UART6_Rx1(void);
void UART6_Rx2(void);


void UART6_TxQueueInit(void);
void UART6_PutQueue(char *msg);

void UART6_SendMsg(char *s);
void UART6_CheckQueue(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
#line 9 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
void Timer_Init();
void TimerCheck();
#line 31 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 43 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
void init_timerpool(void);
#line 52 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
unsigned short int get_timer(void);
#line 61 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
void free_timer(unsigned short int nbr);
#line 71 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 80 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 89 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/timers.h"
void irqhandler_timer(void);





void Timer6_Initialize(void);

unsigned int ReadTimer6(void);
#line 1 "c:/arm projects/mikromedia+ for stm32 arm/loop/loop_code/mikroc pro for arm/loop_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct {
 unsigned int X_Min;
 unsigned int X_Max;
 unsigned int Y_Min;
 unsigned int Y_Max;
 char Rotate;
} TTPConstants;

typedef struct Image {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 const char *Picture_Name;
 char Visible;
 char Active;
 char Picture_Type;
 char Picture_Ratio;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TImage;

typedef struct CircleButton {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Radius;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 const char *FontName;
 unsigned int Font_Color;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TCircleButton;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int ImagesCount;
 TImage * const code *Images;
 unsigned int CircleButtonsCount;
 TCircleButton * const code *CircleButtons;
};

extern TScreen Screen1;
extern TImage Image1;
extern TCircleButton CircleButton1;
extern TImage * const code Screen1_Images[1];
extern TCircleButton * const code Screen1_CircleButtons[1];








extern char Image1_Caption[];
extern char CircleButton1_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawImage(TImage *AImage);
void DrawCircleButton(TCircleButton *ACircle_button);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
#line 13 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/Interrupts.c"
char IntFlag = 0;
char DetFlag = 0;

unsigned int Pass = 0;

unsigned int OldValue = 0;
unsigned int NewValue = 0;
unsigned long Sum;
unsigned int Average;
unsigned int LowThresh;
unsigned int HighThresh;

unsigned int ValueTable[4];
unsigned int InPtr;

unsigned short LoopTimer;
char LoopState = 1;
char Tuned = 0;
#line 54 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/Interrupts.c"
void ExternalInterrupt0() iv IVT_INT_EXTI0 ics ICS_AUTO {

 PR0_bit = 1;

 if (++Pass > 99) {
 Pass = 0;
 IntFlag = 1;
 RGB_Set_Red();
 }
}
#line 68 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/Interrupts.c"
void ExtIntEnable(void) {


 GPIO_Set_Pin_Mode(&GPIOE_BASE, _GPIO_PIN_0, _GPIO_CFG_MODE_INPUT | _GPIO_CFG_PULL_UP);


 MR0_bit = 1;


 TR0_bit = 1;


 TR0_EXTI_FTSR_bit = 0;


 SYSCFGEN_bit = 1;


 SYSCFG_EXTICR1 = 0x00000004;

 NVIC_IntEnable(IVT_INT_EXTI0);

 InPtr = 0;
}
#line 96 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/Interrupts.c"
void CheckPA0Int(void) {
 int i;

 if (IntFlag) {
 IntFlag = 0;
 RGB_Clr_Red();

 NewValue = ReadTimer6();

 Sum = 0;

 ValueTable[InPtr++] = NewValue - OldValue;


 if (InPtr > 3) InPtr = 0;

 for (i=0;i<4;i++) {
 Sum += ValueTable[i];
 }
 Average = (unsigned int)(Sum >> 2);

 OldValue = NewValue;

 if (Tuned) {
 if ((Average < LowThresh) && (DetFlag == 0)) {
 UART6_PutQueue("Vehicle present\r\n");
 DetFlag = 1;
 }

 if ((Average > HighThresh) && (DetFlag == 1)) {
 UART6_PutQueue("Vehicle absent\r\n");
 DetFlag = 0;
 }
 }

 }
}
#line 137 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/Interrupts.c"
void LoopSM(void) {
 int i;
 char *BufNum;

 switch (LoopState) {

 case 0:

 break;

 case 1:
 LoopTimer = get_timer();
 set_timer(LoopTimer,5000);
 UART6_PutQueue("Waiting for loop to stabilize. Please wait...\r\n");
 LoopState = 2;
 break;

 case 2:
 if (check_timer(LoopTimer) == 0) {

 UART6_PutQueue("Tuning loop\r\n");

 HighThresh = Average -  0x10 ;
 LowThresh = Average -  0x20 ;
#line 167 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/Interrupts.c"
 Tuned = 1;
 UART6_PutQueue("Ready\r\n");
 set_timer(LoopTimer,60000);
 LoopState = 3;
 }
 break;

 case 3:
 if ((check_timer(LoopTimer) == 0) && (DetFlag == 0)) {
 UART6_PutQueue("Tuning loop\r\n");
 LoopState = 4;
 }
 break;

 case 4:
 if ((check_timer(LoopTimer) == 0) && (DetFlag == 0)) {
 HighThresh = Average -  0x10 ;
 LowThresh = Average -  0x20 ;
#line 191 "C:/ARM Projects/Mikromedia+ for STM32 ARM/Loop/Loop_Code/mikroC PRO for ARM/Interrupts.c"
 set_timer(LoopTimer,60000);
 LoopState = 3;
 }
 break;


 }
}
